local L = AceLibrary("AceLocale-2.2"):new("Omen")
local OmenRogue = OmenClassModuleCore:NewModule("ROGUE")

function OmenRogue:ClassInit()	
	self.className = "ROGUE"
	self.passiveThreatModifiers = 0.71
	
	-- Scan talents
	local name, iconTexture, tier, column, rank = GetTalentInfo(3, 3)
	self.feintMod = 1 + (0.1 * rank)
	
	-- CastBuff handlers should take a multiplier and modify it by any multipliers they infer
	self.ClassBuffs[L["Vanish"]] = function(a) return 0 end
	
	-- CastHandlers should return true if they modified the threat level, false if they don't
	self.CastHandlers[L["Feint"]] = self.Feint

	self.feintThreatAmounts = {
		-150, -240, -390, -600, -800, -1050
	}
	
	-- ThreatMods should return the modifications (if any) to the threat passed in
	self.abilityThreatMods[L["Sinister Strike"]]	= self.BonescytheBonus
	self.abilityThreatMods[L["Backstab"]]			= self.BonescytheBonus
	self.abilityThreatMods[L["Hemorrhage"]]			= self.BonescytheBonus
	self.abilityThreatMods[L["Eviscerate"]]			= self.BonescytheBonus	
	
	-- Set names don't need to be localized.
	self.itemSets = {
		["Bloodfang"] = { 16908, 16909, 16832, 16906, 16910, 16911, 16905, 16907 },
		["Bonescythe"] = { 22478, 22477, 22479, 22480, 22482, 22483, 22476, 22481, 23060}
	}
end

function OmenRogue:Feint(rank)
	local bfBonus = 1
	if self:getWornSetPieces("Bloodfang") >= 5 then
		bfBonus = 1.2
	end
	self:AddTargetThreat(self.feintThreatAmounts[tonumber(rank)] * self.feintMod * self:threatMods() * bfBonus)
end

function OmenRogue:BonescytheBonus(amt)
	if self:getWornSetPieces("Bonescythe") >= 6 then
		return amt * 0.92
	end
	return amt
end